{% extends 'dashboard/dashboard_content.html' %}

{% block title %}
    Enable Courses
{% endblock %}

{% block head_block %}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/css/select2.min.css" rel="stylesheet"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/js/select2.min.js"></script>

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.11.2/css/bootstrap-select.min.css">

    <!-- Latest compiled and minified JavaScript -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.11.2/js/bootstrap-select.min.js"></script>


{% endblock %}

{% block rightPane %}
    <div class="x_panel">
        <div class="x_title">
            <h2>
                <i class="fa fa-stack-overflow"></i>
                Enable Courses for enrollment of a Student
            </h2>
            <div class="clearfix"></div>
        </div>
        <div class="x_content">
            <div class="row">
                <div class="col-md-12 col-sm-12 col-xs-12">
                    {% load static %}
                    {% get_media_prefix as MEDIA_ROOT %}

                    <form id="demo-form2" class="form-horizontal form-label-left" data-parsley-validate=""
                          novalidate="">
                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                Department
                            </label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <select class="selectpicker form-control" name="dept" id="dept" data-width="auto"
                                        required>
                                    <option disabled selected>-----------</option>
                                    {% for each in dept_list %}
                                        <option value="{{ each.id }}"
                                                data-subtext="{{ each.acronym }}">{{ each }}</option>
                                    {% endfor %}
                                </select>
                            </div>
                        </div>

                        <div class="form-group" style="display: none" id="year_div">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                Year of Study
                            </label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <select name="year" id="year" class="form-control"
                                        required>
                                    <option disabled selected>-----------</option>
                                </select>
                            </div>
                        </div>

                        <div class="form-group" style="display: none" id="student_div">
                            <input type="hidden" id="semester_pk" value="0">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                Student
                            </label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <select name="student" id="student" class="form-control"
                                        required>
                                    <option disabled selected>-----------</option>
                                </select>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
            <div class="col-md-12" id="offered_div" hidden>
                <br><br>
                <div class="col-md-12    col-sm-12 col-xs-12">
                    <div class="x_panel">
                        <div class="x_title">
                            <h2>
                                List of Offered Courses
                            </h2>
                            <ul class="nav navbar-right panel_toolbox">
                                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                                </li>
                            </ul>
                            <div class="clearfix"></div>
                        </div>
                        <div class="x_content">
                            <div class="table-responsive">
                                <table class="table table-hover table-striped">
                                    <thead>
                                    <tr>
                                        <th>S. No.</th>
                                        <th>Course ID</th>
                                        <th>Course Name</th>
                                        <th>Semester</th>
                                    </tr>
                                    </thead>
                                    <tbody id="content_offered">
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div role="alert" id="error_msg" class="alert alert-success alert-dismissible fade in" hidden>
                <h4 id="error_text"></h4>
            </div>
            <div class="col-md-12" id="available_div" hidden>
                <br><br>
                <div class="col-md-12    col-sm-12 col-xs-12">
                    <div class="x_panel">
                        <div class="x_title">
                            <h2>
                                List of Courses Available
                            </h2>
                            <ul class="nav navbar-right panel_toolbox">
                                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                                </li>
                            </ul>
                            <div class="clearfix"></div>
                        </div>
                        <div class="x_content">
                            <div class="table-responsive">
                                <table class="table table-hover table-striped">
                                    <thead>
                                    <tr>
                                        <th>S. No.</th>
                                        <th>Course ID</th>
                                        <th>Course Name</th>
                                        <th>Semester</th>
                                    </tr>
                                    </thead>
                                    <tbody id="content">
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>


    <script type="text/javascript">

        //For getting CSRF token
        function getCookie(name) {
            var cookieValue = null;
            if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }
        $(document).on("change", '#dept', function (e) {
            var dept = $(this).val();
            //alert(dept)


            $.ajax({
                type: "POST",
                data: {
                    department: dept,
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'enable_courses' %}',
                success: function (data) {
                    $('#available_div').hide();
                    $('#offered_div').hide();
                    $('#year_div').show();
                    $('#student_div').hide();
                    $('#student').empty();
                    document.getElementById('content').innerHTML = "";
                    $('#year').empty();
                    $('#year').append('<option disabled selected>' + '-----------' + '</option>');
                    $.each(data.list, function (key, val) {
                        $('#year').append('<option value="' + val.batch_obj + '">' + val.display_batch + '</option>');
                    })
                }
            });
        });

        $(document).on("change", '#year', function (e) {
            var year = $(this).val();
            var department = $('#dept').val();
            //alert(department);


            $.ajax({
                type: "POST",
                data: {
                    year: year,
                    dept: department,
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'enable_courses' %}',

                success: function (data) {
                    $('#available_div').hide();
                    $('#offered_div').hide();
                    $('#student_div').show();
                    document.getElementById('content').innerHTML = "";
                    $('#student').empty();
                    $('#student').append('<option disabled selected>' + '-----------' + '</option>');
                    $.each(data.list, function (key, val) {
                        $('#student').append('<option value="' + val.regno + '">' + val.regno + ' - ' + val.name + '</option>');
                    })
                }
            });

        });

        $(document).on("change", '#student', function (e) {
            var year = $('#year').val();
            var department = $('#dept').val();
            var student = $(this).val();
            //alert(department);


            $.ajax({
                type: "POST",
                data: {
                    hidden_year: year,
                    hidden_dept: department,
                    student: student,
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'enable_courses' %}',

                success: function (data) {
                    $('#error_msg').hide();
                    $('#available_div').hide();
                    $('#offered_div').hide();
                    document.getElementById('error_text').innerHTML = "";
                    document.getElementById('content').innerHTML = "";
                    document.getElementById('content_offered').innerHTML = "";

                    if (data.no_sem_plan == 'true') {
                        $('#error_msg').show();
                        document.getElementById('error_text').innerHTML = "No section has assigned for " + data.student;
                    }
                    else {

                        $('#available_div').show();
                        $('#offered_div').show();
                        counter = 1;
                        document.getElementById('semester_pk').setAttribute('value', '' + data.semester_pk + '');
                        $.each(data.list, function (key, val) {
                            document.getElementById('content').innerHTML += '<tr>' +
                                '<td>' + counter++ + '</td>' +
                                '<td>' + val.course_id + '</td>' +
                                '<td>' + val.course_name + '</td>' +
                                '<td>' + val.semester + '</td>' +
                                '<td>' +
                                '<button class=\"btn-rounded btn btn-dark-green\" name=\"course_enable\" id=\"' + val.pk + '\" type=\"submit\">' +
                                'Enable' +
                                '</button>' +
                                '</td>' +
                                '</tr>';
                        });
                        counter = 1;
                        $.each(data.list_offered, function (key, val) {
                            document.getElementById('content_offered').innerHTML += '<tr>' +
                                '<td>' + counter++ + '</td>' +
                                '<td>' + val.course_id + '</td>' +
                                '<td>' + val.course_name + '</td>' +
                                '<td>' + val.semester + '</td>' +
                                '<td>' +
                                '<button class=\"btn-rounded btn btn-danger\" name=\"course_delete\" id=\"' + val.pk + '\" type=\"submit\">' +
                                'Disable' +
                                '</button>' +
                                '</td>' +
                                '</tr>';
                        });
                    }

                }
            });

        });

        $(document).on("click", '[name="course_enable"]', function (e) {
            var year = $('#year').val();
            var department = $('#dept').val();
            var student = $('#student').val();
            var course_id = this.id;


            $.ajax({
                type: "POST",
                data: {
                    hidden_year: year,
                    hidden_dept: department,
                    hidden_student: student,
                    course_id: course_id,
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'enable_courses' %}',

                success: function (data) {
                    document.getElementById('content').innerHTML = "";
                    document.getElementById('content_offered').innerHTML = "";
                    counter = 1;
                    $.each(data.list, function (key, val) {
                        document.getElementById('content').innerHTML += '<tr>' +
                            '<td>' + counter++ + '</td>' +
                            '<td>' + val.course_id + '</td>' +
                            '<td>' + val.course_name + '</td>' +
                            '<td>' + val.semester + '</td>' +
                            '<td>' +
                            '<button class=\"btn-rounded btn btn-dark-green\" name=\"course_enable\" id=\"' + val.pk + '\" type=\"submit\">' +
                            'Enable' +
                            '</button>' +
                            '</td>' +
                            '</tr>';
                    });
                    counter = 1;
                    $.each(data.list_offered, function (key, val) {
                        document.getElementById('content_offered').innerHTML += '<tr>' +
                            '<td>' + counter++ + '</td>' +
                            '<td>' + val.course_id + '</td>' +
                            '<td>' + val.course_name + '</td>' +
                            '<td>' + val.semester + '</td>' +
                            '<td>' +
                            '<button class=\"btn-rounded btn btn-danger\" name=\"course_delete\" id=\"' + val.pk + '\" type=\"submit\">' +
                            'Disable' +
                            '</button>' +
                            '</td>' +
                            '</tr>';
                    });
                }
            });

        });

        $(document).on("click", '[name="course_delete"]', function (e) {
            var year = $('#year').val();
            var department = $('#dept').val();
            var student = $('#student').val();
            var course_id = this.id;


            $.ajax({
                type: "POST",
                data: {
                    hidden_year: year,
                    hidden_dept: department,
                    hidden_student: student,
                    delete_course_id: course_id,
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'enable_courses' %}',

                success: function (data) {
                    document.getElementById('content').innerHTML = "";
                    document.getElementById('content_offered').innerHTML = "";
                    counter = 1;
                    $.each(data.list, function (key, val) {
                        document.getElementById('content').innerHTML += '<tr>' +
                            '<td>' + counter++ + '</td>' +
                            '<td>' + val.course_id + '</td>' +
                            '<td>' + val.course_name + '</td>' +
                            '<td>' + val.semester + '</td>' +
                            '<td>' +
                            '<button class=\"btn-rounded btn btn-dark-green\" name=\"course_enable\" id=\"' + val.pk + '\" type=\"submit\">' +
                            'Enable' +
                            '</button>' +
                            '</td>' +
                            '</tr>';
                    });
                    counter = 1;
                    $.each(data.list_offered, function (key, val) {
                        document.getElementById('content_offered').innerHTML += '<tr>' +
                            '<td>' + counter++ + '</td>' +
                            '<td>' + val.course_id + '</td>' +
                            '<td>' + val.course_name + '</td>' +
                            '<td>' + val.semester + '</td>' +
                            '<td>' +
                            '<button class=\"btn-rounded btn btn-danger\" name=\"course_delete\" id=\"' + val.pk + '\" type=\"submit\">' +
                            'Disable' +
                            '</button>' +
                            '</td>' +
                            '</tr>';
                    });
                }
            });

        });

    </script>

{% endblock %}